                     /*-----------------------------------*/
                     /*             >>>Slip<<<            */
                     /*            Theo D'Hondt           */
                     /*     VUB Software Languages Lab    */
                     /*             (c) 2010              */
                     /*-----------------------------------*/
                     /*   version 9: garbage collection   */
                     /*-----------------------------------*/
                     /*              threads              */
                     /*-----------------------------------*/

/*------------------------------- public macros ------------------------------*/

#define BEGIN_THREAD_FRAME(SIG)                                                \
  typedef struct SIG * SIG##_type;                                             \
  struct SIG { CEL_type hdr;                                                   \
               NBR_type tid;                                                   \
               VEC_type thr

#define END_THREAD_FRAME(SIG)                                                  \
  } SIG;                                                                       \
static const UNS_type SIG##_size = ((sizeof(SIG) / sizeof(CEL_type)) - 2)

#define THREAD_FRAME_SLOT(SIG, NAM)                                            \
  SIG##_type NAM

/*------------------------------ public prototypes ---------------------------*/

VOI_type      Thread_Clear(VOI_type);
VEC_type       Thread_Keep(VOI_type);
VEC_type       Thread_Peek(VOI_type);
VEC_type     Thread_Poke_M(NBR_type,
                           UNS_type);
VEC_type      Thread_Patch(NBR_type);
VEC_type     Thread_Push_M(NBR_type,
                           UNS_type);
NBR_type   Thread_Register(CCC_type);
CCC_type   Thread_Retrieve(VOI_type);
VOI_type        Thread_Zap(VOI_type);

/*------------------------------ initialization ------------------------------*/

VOI_type Thread_Initialize(VOI_type);