                     /*-----------------------------------*/
                     /*             >>>Slip<<<            */
                     /*            Theo D'Hondt           */
                     /*     VUB Software Languages Lab    */
                     /*             (c) 2010              */
                     /*-----------------------------------*/
                     /*   version 9: garbage collection   */
                     /*-----------------------------------*/
                     /*               pool                */
                     /*-----------------------------------*/

/*----------------------------- public constants -----------------------------*/

static const TXT_type Pool_Anonymous_Text   = "anonymous";
static const TXT_type Pool_Application_Text = "application";
static const TXT_type Pool_Begin_Text       = "begin";
static const TXT_type Pool_Define_Text      = "define";
static const TXT_type Pool_If_Text          = "if";
static const TXT_type Pool_Lambda_Text      = "lambda";
static const TXT_type Pool_Load_Text        = "load";
static const TXT_type Pool_Quote_Text       = "quote";
static const TXT_type Pool_Set_Text         = "set!";
static const TXT_type Pool_While_Text       = "while";

/*----------------------------- public variables -----------------------------*/

extern SYM_type Pool_Anonymous_P;
extern SYM_type Pool_Application_P;
extern SYM_type Pool_Begin_P;
extern SYM_type Pool_Define_P;
extern SYM_type Pool_If_P;
extern SYM_type Pool_Lambda_P;
extern SYM_type Pool_Load_P;
extern SYM_type Pool_Quote_P;
extern SYM_type Pool_Set_P;
extern SYM_type Pool_While_P;

/*----------------------------- public prototypes ----------------------------*/

SYM_type           Pool_Enter_C(TXT_type);
VOI_type Pool_Enter_Native_Name(TXT_type,
                                UNS_type);
TXT_type   Pool_Get_Native_Name(UNS_type);

/*------------------------------ initialization ------------------------------*/

VOI_type      Pool_Initialize_M(VOI_type);                     